// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDirectoryModel")]
    pub struct DirectoryModel(Object<ffi::DzlDirectoryModel, ffi::DzlDirectoryModelClass>) @implements gio::ListModel;

    match fn {
        type_ => || ffi::dzl_directory_model_get_type(),
    }
}

impl DirectoryModel {
    #[doc(alias = "dzl_directory_model_get_directory")]
    #[doc(alias = "get_directory")]
    pub fn directory(&self) -> Option<gio::File> {
        unsafe {
            from_glib_none(ffi::dzl_directory_model_get_directory(
                self.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_directory_model_set_directory")]
    pub fn set_directory(&self, directory: &impl IsA<gio::File>) {
        unsafe {
            ffi::dzl_directory_model_set_directory(
                self.to_glib_none().0,
                directory.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_directory_model_set_visible_func")]
    pub fn set_visible_func<
        P: Fn(&DirectoryModel, &gio::File, &gio::FileInfo) -> bool + 'static,
    >(
        &self,
        visible_func: P,
    ) {
        let visible_func_data: Box_<P> = Box_::new(visible_func);
        unsafe extern "C" fn visible_func_func<
            P: Fn(&DirectoryModel, &gio::File, &gio::FileInfo) -> bool + 'static,
        >(
            self_: *mut ffi::DzlDirectoryModel,
            directory: *mut gio::ffi::GFile,
            file_info: *mut gio::ffi::GFileInfo,
            user_data: glib::ffi::gpointer,
        ) -> glib::ffi::gboolean {
            let self_ = from_glib_borrow(self_);
            let directory = from_glib_borrow(directory);
            let file_info = from_glib_borrow(file_info);
            let callback: &P = &*(user_data as *mut _);
            (*callback)(&self_, &directory, &file_info).into_glib()
        }
        let visible_func = Some(visible_func_func::<P> as _);
        unsafe extern "C" fn user_data_free_func_func<
            P: Fn(&DirectoryModel, &gio::File, &gio::FileInfo) -> bool + 'static,
        >(
            data: glib::ffi::gpointer,
        ) {
            let _callback: Box_<P> = Box_::from_raw(data as *mut _);
        }
        let destroy_call3 = Some(user_data_free_func_func::<P> as _);
        let super_callback0: Box_<P> = visible_func_data;
        unsafe {
            ffi::dzl_directory_model_set_visible_func(
                self.to_glib_none().0,
                visible_func,
                Box_::into_raw(super_callback0) as *mut _,
                destroy_call3,
            );
        }
    }

    #[doc(alias = "dzl_directory_model_new")]
    pub fn new(directory: &impl IsA<gio::File>) -> Option<gio::ListModel> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::dzl_directory_model_new(
                directory.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "directory")]
    pub fn connect_directory_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_directory_trampoline<F: Fn(&DirectoryModel) + 'static>(
            this: *mut ffi::DzlDirectoryModel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::directory\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_directory_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for DirectoryModel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DirectoryModel")
    }
}
